#!/usr/bin/expect

log_user 0

proc transf {cs dat} {
  #puts [format "writereg 4 37 %x\r\n" [expr {(($cs << 10) | 0x100 ) | $dat}]]
  send [format "writereg 4 37 %x\r\n" [expr {(($cs << 10) | 0x100 ) | $dat}]]
  expect "%>"
  while 1 {
    send "readreg 4 37\r\n"
    expect "%>"
    set resp [split $expect_out(buffer) "\r\n"]
    set resp [lindex $resp 2]
    set resp [split $resp]
    set resp [lindex $resp 3]
    #puts $resp
    if {$resp & [expr {0x20}]} {
    } else {
      break
    }
  }
  return [expr {$resp & [expr {0xFF}]}]
}

proc flse {addr} {
  transf 0 0
  transf 1 [expr {0x06}]
  transf 0 0 
  transf 1 [expr {0xd8}]
  transf 1 [expr {($addr & 0xFF0000) >> 16}]
  transf 1 [expr {($addr & 0xFF00) >> 8}]
  transf 1 [expr {($addr & 0xFF)}]
  transf 0 0
}

proc flrsr {} {
  transf 0 0
  transf 1 [expr {0x05}]
  set ret [transf 1 0]
  transf 0 0
  return $ret
}

proc flw {addr dat} {
  transf 0 0
  transf 1 [expr {0x06}]
  transf 0 0
  transf 1 [expr {0x02}]
  transf 1 [expr {($addr & 0xFF0000) >> 16}]
  transf 1 [expr {($addr & 0xFF00) >> 8}]
  transf 1 [expr {($addr & 0xFF)}]
  for {set i 0} {$i < 256} {incr i} {
    transf 1 [lindex $dat $i]
  }
  transf 0 0
}

spawn telnet elma
expect "login:"
send "admin\r\n"
expect "password:"
send "ADMIN\r\n"
expect "%>"
set dat {0 1 2}
for {set i 3} {$i < 256} {incr i} {
  lappend dat $i
}
puts "ERASE"
set t0 [
  time {
    flse 0
    set wip [expr {0x01}]
    while {[expr {$wip & 0x01}]} {
      set wip [flrsr]
    }
  }
]
puts "WRITE"
set addr 0
while {[expr {$addr != [expr {256*256}]}]} {
  puts $addr
  set t1 [
    time {
      flw $addr $dat
      set wip [expr {0x01}]
      while {[expr {$wip & 0x01}]} {
        set wip [flrsr]
      }
      set addr [expr {$addr + 256}]
    }
  ]
}

send \x1D
expect "telnet>"
send "q\n"
expect eof

puts $t0
puts $t1
